<?php
# ***** BEGIN LICENSE BLOCK *****
# This file is part of DotClear.
# Copyright (c) 2004 Thomas Humeau and contributors. All rights
# reserved.
#
# DotClear is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# DotClear is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with DotClear; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# ***** END LICENSE BLOCK *****

require_once dirname(__FILE__).'/pano_config.php';
	
#Creation du code HTML pour le billet contenant le panorama 
if (!empty($_REQUEST['action']))
{
	// retrieve the data entered in the plugin form
	$pano_title = trim($_POST['pano_title']);
	$pano_description = trim($_POST['pano_description']);
	$pano_url = trim($_POST['p_content']);
	$pano_hfov = trim($_POST['pano_hfov']);

	if (($rs = $blog->getCat()) === false) {
		echo "<p>\n";
		echo "Erreur MySQL can not get categories";
		echo "</p>\n";
		exit;
	}
	$blog_url = 'http://'.$_SERVER['HTTP_HOST'];
	
	// The image manager in the plugin gives the image in the wiki format so this retrieves the name of the file only
	$pano_url= trim($pano_url,'((') ;
	$pano_url= trim($pano_url,'))') ;
	if ($pano_url == trim($pano_url,'http')){
		$pano_url = $blog_url.$pano_url;
	}

	// prepares other applet settings
	$pano_size = getimagesize($pano_url);
	$pwidth = floor($pano_size['0'] * 360 / $pano_hfov);
	$x_pos = floor(($pwidth/2) - ($pano_size['0']/2));
	$pan = floor(($pano_hfov/2)-1);
	
	$titre = $pano_title;
	$titre_url = '';
	
	// Prepares the post chapo
	// If a thumbnail file is provided, it will be used for the abstract display
	// If the image is image.jpg the thumbnail must be named image_small.jpg and the thumbnail must be at least 500px wide
	$pano_url_small = trim($pano_url,'.jpg').'_small.jpg';
	$pano_url_small_size = getimagesize($pano_url_small);
	if($pano_url_small_size[0] < $pano_TB_width){
		$pano_url_small = $pano_url;
	}
	$chapo = $pano_description.'<BR /><BR /><img src="'.$pano_url_small.'" width='.$pano_TB_width.' />';
	
	// Prepares the Post content for 360 panoramas
	if($pano_hfov==360 || !$pano_hfov){
	$pano_content = $pano_description
		.'<br /><br /><applet id="panorama" codebase="./" code="ptviewer.class" archive="'.$blog_url.dc_app_url.'/ecrire/tools/panorama/ptviewer.jar" width='.$pano_width.' height='.$pano_height.'>
		'.'<param name=file value="'.$pano_url.'">
		'.'<param name=cursor value="MOVE">
		'.'<param name=showToolbar value="true">
		'.'<param name="auto" value='.$auto_speed.'>
		'.'<param name=imgLoadFeedback value="false">
		'.'<param name=bgcolor value="'.$bgcolor.'">
		'.'<param name=wait value="'.$blog_url.dc_app_url.'/ecrire/tools/panorama/loading.gif">
		'.'<param name=waittime value="0">
		'.'</applet>';
	}
	// Prepares the Post content for partial  panoramas
	else{
	$pano_content = $pano_description.
		'<br /><br /><applet id="ptviewer" name="ptviewer" archive='.$blog_url.dc_app_url.'/ecrire/tools/panorama/ptviewer.jar  code=ptviewer.class width='.$pano_width.' height='.$pano_height.'>
		'.'<param name=pwidth    value='.$pwidth.' >
		'.'<param name=pheight   value='.$pano_size[1].' >
		'.'<param name=roi0      value="i\''.$pano_url.'\' x'.$x_pos.' y0" >
		'.'<param name=panmin    value=-'.$pan.' >
		'.'<param name=panmax    value= '.$pan.' >
		'.'<param name=fov    value='.$pano_hfov.'>
		'.'<param name="auto" value='.$auto_speed.'>
		'.'<param name=bgcolor value="'.$bgcolor.'">
		'.'<param name=grid_bgcolor value="'.$grid_bgcolor.'">
		'.'<param name=grid_fgcolor value="'.$grid_fgcolor.'">
		'.'<param name=showToolbar value="true">
		'.'<param name=wait value="'.$blog_url.dc_app_url.'/ecrire/tools/panorama/loading.gif">
		'.'<param name=waittime value="0">
		'.'</applet>';
	}

	$notes = '';
	$cat_id = $rs->f('cat_id');
	$format = 'html';
	// add the post to the database
	if (($post_id = $blog->addPost($_SESSION['sess_user_id'],$titre,$titre_url,
		 $chapo,$pano_content,$notes,$cat_id,$format)) !== false) {
		$my_new_post = $blog->getPostByID($post_id);
		$titre_url = $my_new_post->getPermURL();
		
		// Updates the abstract including the link to the post on the image
		$chapo = $pano_description.'<BR /><a href="'.$titre_url.'"><img src="'.$pano_url_small.'" width=500 /></a>';
		$blog->updPost($post_id,$titre,$titre_url,$chapo,$pano_content,$notes,$cat_id);
	$return_link = 'poster.php?post_id='.$post_id;

	// switches to the editor
	header('Location: '.$return_link);
	exit;
	}
}


# affichage du plugin
#
# It uses the DC image manager that is used in the post editor ()images.php and images-popup.php
# The DC image manager returns the wiki format for the image so the image file appears with ((...))  This is corrected before inserting the post.
#

buffer::str('<h2>'.__('Panorama Plugin').'</h2>');

	buffer::str(
	'<form action="'.$url.'" method="post">'.'</p>
	'.'<fieldset><legend>'.__('Panorama parameters').'</legend>'.'</p>

	'.'<p class="field"><strong>'.'</p>
	'.'<label for="pano_url" class="float">'.__('panorama image URL').' : </label></strong>'.'</p>
	'.form::field('p_content',40,255).'</p>
	'.'or select image from manager: <a href="http://'.$_SERVER['HTTP_HOST'].dc_app_url.'/ecrire/images-popup.php" onclick="popup(this.href); return false;"><img src="images/bt_img.png" /></a>


	'.'<p class="field"><strong>'.'</p>
	'.'<label for="pano_title" class="float">'.__('Panorama title').' : </label></strong>'.'</p>
	'.form::field('pano_title',40,255,'my panorama').'</p>
	
	'.'<p class="field">'.'</p>
	'.'<label for="pano_description" class="float">'.__('description (optional)').' : </label>'.'</p>
	'.form::field('pano_description',40,255,htmlspecialchars($pano_description)).'</p>
	
	'.'<p class="field">'.'</p>
	'.'<label for="pano_hfov" class="float">'.__('horizontal field of view').':  '.helpLink('index&amp;plugin=panorama','default_lang').'</label>'.'</p>
	'.form::field('pano_hfov',40,255,360).' Value between 0 and 360 (default is 360).
	
	'.'</td> <br />
	'.'<td><input type="hidden" id="p_format" name="p_format" value="wiki" /></td>
	
	'.'<p>'.form::hidden('action','add_panorama').
	'<input type="submit" class="submit" value="'.__('post entry').'"/></p>
	'.'</fieldset>
	'.'</form>'
	);

buffer::str('</p>');

	buffer::str(
	'<fieldset><legend>'.__('Panorama usage').'</legend>'.'</p>
	'.'<p class="field">'.'</p>
	'.'<label for="pano_help">'.__('_ In the \'panorama image URL\' field, you can either put your external URL like: "HTTP://www.mysite.com/.../my_panorama.jpg" <br />
	or you can use the image manager to choose a panorama image from the images you uploaded to the "/image" folder.<br /> If you use the image manager, it will insert an image in WIKI format. You shouldn\'t modify that since the plugin takes care of it. <br /><br />
	_ After you have posted you entry, you will be automatically redirected to the post editing page where you can modify the generated code at your convenience.<br /><br />
	_ If you wish to change the parameters of the panorama display, you can edit the \'pano_config.php\' file in the /tools/panorama folder<br /><br />
	_ A thumbnail file can be provided to be used for the abstract display<br /><br />
	_ With a panorama image named pano.jpg the thumbnail must be named pano_small.jpg, placed in the same folder and the thumbnail must be at least 500px wide (this can be customized by by changing $pano_TB_width in \'pano_config.php\')<br /><br />
	_ For a better experience, it is advised not to show the abstract ("chapo") when viewing the panorama post. In order to do that, you should edit \'post.php\' in your theme and comment the line that shows the chapo at the beginning of the file: \'dcPostChapo...\'
 	
	').'</label>
	</td> <br />
	</fieldset>'
	);

?>

